
// Copyright (c) 2020-2021, ARM Limited.
//
//    Licensed under the Apache License, Version 2.0 with LLVM Exceptions
//    (the "License"); you may not use this file except in compliance with
//    the License. You may obtain a copy of the License at
//
//         https://llvm.org/LICENSE.txt
//
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.

#ifndef INCLUDE_SERIALIZATION_PASSES_H
#define INCLUDE_SERIALIZATION_PASSES_H

#include <memory>

#include "mlir/Dialect/Func/IR/FuncOps.h" // from @llvm-project
#include "mlir/IR/BuiltinOps.h"
#include "mlir/Pass/Pass.h" // from @llvm-project

namespace mlir {
namespace tosa {

std::unique_ptr<OperationPass<ModuleOp>> createTosaSerializePass();
std::unique_ptr<Pass> createTosaSerializeJSONPass();

#define GEN_PASS_REGISTRATION
#define GEN_PASS_CLASSES
#define GEN_PASS_DECL_TOSASERIALIZEPASS
#include "include/SerializationPasses.h.inc"

} // namespace tosa
} // namespace mlir

#endif // INCLUDE_SERIALIZATION_PASSES_H
